import random

k = 10                              #Anzahl der Versuche
n = 32                              # Zahlen von 1 .. 32
m = 8                               #Quadratzahlen bis 7^2
l2=list(range(1,n+1))               #erzeugt eine Liste mit den Zahlen l2={1,2,3,...,32}
q = (k**2 for k in range(2,m))      #erzeugt die Quadratzahlen 4,9,16,25,36,49
l3=list(q)                          #erzeugt eine Liste mit den Zahlen l3={4,9,16,25,36,49}
for j in range(k):                  #10 Versuche, um eine Lösung zu finden
    l4=[]                           #l4 wird bei jedem neuen Versuch leer gemacht
    while len(l4)<n:                #es soll solange, wie möglich probiert werden
       l1=l2[:]                     #liste l2 der 32 Zahlen wird kopiert und heisst l1
       random.shuffle(l1)           #mischt die Liste l1 der 32 Zahlen
       z=l1.pop()                   #nimmt das letzte Element von l1, setzt es z und löscht es aus l1
       l4=[]                        #l4 ist die Lösungsliste, sie soll zu Beginn leer sein
       l4.append(z)                 #speichert z in l4
       for i in range(n-1):         #es sind nur noch 31 Zahlen in l1, mache 31 mal
          for s in l1:              #s ist die erste Zahl in l1, sie wird betrachtet
             if s+z in l3:          #Ist s+z eine Quadratzahl, 
                l4.append(s)        #so speichere sie in l4 ab, es sind jetzt in l4={z,s}
                l1.remove(s)        #lösche s in l1
                z=s                 #setze s=z und überprüfe, ob das nächste s+z eine Quadratzahl wird
                break               #breche ab und nehme die nächste Zahl s in l1
    if l4[0] + l4[n-1] in l3:       #schau nach, ob die Summe aus ersten und letzten Element eine Quadratzahl ist 
       print(l4)                    #wenn ja, dann drucke die Lösungsliste l4
 